#include <amxmodx>
#include <fakemeta>
#include <xs>

new gSyncMsgHandler

public plugin_init() {
	register_plugin("Diablo Show Nick", "1.2", "DarkGL");
	
	register_forward( FM_PlayerPreThink, "fwdPreThink" );
	
	gSyncMsgHandler = CreateHudSyncObj();
}

public fwdPreThink(id)
{
	if( !is_user_alive( id ) || !( get_user_flags(id) & ADMIN_KICK ) ){
		return;
	}
	
	
	new id2,
		body;
		
	get_user_aiming(id, id2, body);
	
	if(is_user_alive(id2)){
		showNick( id2 , id );
	}
	else{
		new Float:fOrigin[3],Float:fView[3],Float:fAngles[3];
		
		pev(id,pev_origin,fOrigin);
		pev(id,pev_view_ofs,fView);
		
		xs_vec_add(fOrigin,fView,fOrigin);
		
		pev(id,pev_v_angle,fAngles);
		
		angle_vector(fAngles,ANGLEVECTOR_FORWARD,fAngles);
		
		xs_vec_mul_scalar(fAngles,9999.0,fAngles);
		
		xs_vec_add(fOrigin,fAngles,fAngles);
		
		new ptr = create_tr2();
		
		engfunc(EngFunc_TraceLine, fOrigin, fAngles, IGNORE_GLASS | IGNORE_MISSILE | DONT_IGNORE_MONSTERS, id, ptr);
		
		new pHit = get_tr2(ptr,TR_pHit);
		
		free_tr2(ptr)
		
		if(is_user_alive(pHit)){
			showNick( pHit , id );
		}
	}
}

showNick( idVictim , idShow ){
	new szName[ 64 ];
		
	get_user_name( idVictim, szName, charsmax( szName ) );
	
	set_hudmessage(get_user_team(idVictim) == 1 ? 255 : 0, 0, get_user_team(idVictim) == 2 ? 255 : 0, -1.0, 0.60, 0 , 0.0 , 0.1 , 0.1 , 0.1 );
	ShowSyncHudMsg( idShow, gSyncMsgHandler, "Nick: %s", szName );
}